package main;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

import utils.Hash;
import utils.HashingException;
import utils.RainbowTable;

public class RainbowCrack {

	private String mdpBaseLigne;
	private String mdpTravail;
	private String hacheCherche;
	private String hacheTravail;
	private int lg;

	public RainbowCrack(String hache, int tailleMDP) {
		mdpTravail = "";
		mdpBaseLigne = "";
		this.hacheCherche = hache;
		lg = tailleMDP;
		new RainbowTable(0,tailleMDP);
	}

	public void launch() throws IOException, HashingException {
		System.out.println("Je cherche le mdp associé à "+hacheCherche+"\n> "+cherche());
	}
	
	public String cherche() throws IOException, HashingException {
		if(chercherDansTable(hacheCherche)) {
			mdpTravail = mdpBaseLigne;
			hacheTravail = Hash.hash(mdpTravail);
			for(int i=0;i<RainbowTable.NbFonctionsReduce;i++) {
				if(!hacheTravail.equals(hacheCherche)) 
					return mdpTravail;
				mdpTravail = RainbowTable.reduce(0, hacheTravail, lg);
				hacheTravail = Hash.hash(mdpTravail); 
			}
			return mdpTravail;
		}
		// on n'a pas trouvé dans la table
		int i=0;
		hacheTravail = Hash.hash(RainbowTable.reduce(0,hacheCherche,lg));
		while(i<10000 && chercherDansTable(hacheTravail)) {
			i++;
		}
		if(i==10000) 
			return "Pas Trouvé";
		// on reprend la meme chose
		mdpTravail = mdpBaseLigne;
		hacheTravail = Hash.hash(mdpTravail);
		for(int j=0;j<RainbowTable.NbFonctionsReduce;j++) {
			if(!hacheTravail.equals(hacheCherche)) 
				return mdpTravail;
			mdpTravail = RainbowTable.reduce(0, hacheTravail, lg);
			hacheTravail = Hash.hash(mdpTravail); 
		}
		return mdpTravail;
	}
	
	public boolean chercherDansTable(String objectif) throws IOException {
		BufferedReader buf = new BufferedReader(new FileReader("RainbowTable0.txt"));
		String read = "";
		while((read=buf.readLine())!=null) {
			if(read.contains(objectif)) {
				mdpBaseLigne = read.substring(0,read.lastIndexOf('-')-1);
				return true;
			}
		}
		buf.close();
		return false;
	}

}
