package test;

import static org.junit.Assert.*;

import java.util.ArrayList;
import java.util.HashMap;

import main.BruteForce;

import org.junit.Before;
import org.junit.Test;

import utils.BruteForceMethod;

public class BruteForceTest {
	private BruteForce brute;
	private ArrayList<String> list;
	int maxLength, threadCount;
	BruteForceMethod method;

	@Before
	public void config(){
		brute = new BruteForce();
		list = new ArrayList<String>();
		maxLength = 4;
		threadCount = 2;
		method = BruteForceMethod.REDUCE;
	}
	
	@Test
	public void simple() throws Exception {
		list.add("569cf10e537ad6a3810d714f99355b93"); // toit
		maxLength = 4;

		HashMap<String, String> result = brute.bruteForceShared(list, method, maxLength, threadCount);
		
		assertEquals("toit", result.get("569cf10e537ad6a3810d714f99355b93"));
	}
	
	@Test
	public void simpleTimeMax1() throws Exception {
		list.add("23f1ea69965c5a68aa61f751dbae2179"); // bonjour
		maxLength = 1;

		HashMap<String, String> result = brute.bruteForceShared(list, method, maxLength, threadCount);
		
		assertEquals(null, result.get("23f1ea69965c5a68aa61f751dbae2179"));
	}
	
	@Test
	public void simpleTimeMax2() throws Exception {
		list.add("23f1ea69965c5a68aa61f751dbae2179"); // bonjour
		maxLength = 2;
		
		HashMap<String, String> result = brute.bruteForceShared(list, method, maxLength, threadCount);
		
		assertEquals(null, result.get("23f1ea69965c5a68aa61f751dbae2179"));
	}
	
	@Test
	public void simpleTimeMax3() throws Exception {
		list.add("23f1ea69965c5a68aa61f751dbae2179"); // bonjour
		maxLength = 3;

		HashMap<String, String> result = brute.bruteForceShared(list, method, maxLength, threadCount);
		
		assertEquals(null, result.get("23f1ea69965c5a68aa61f751dbae2179"));
	}
	
	@Test
	public void simpleTimeMax4() throws Exception {
		list.add("23f1ea69965c5a68aa61f751dbae2179"); // bonjour
		maxLength = 4;

		HashMap<String, String> result = brute.bruteForceShared(list, method, maxLength, threadCount);
		
		assertEquals(null, result.get("23f1ea69965c5a68aa61f751dbae2179"));
	}
	
	@Test
	public void simpleTimeMax6() throws Exception {
		list.add("8a668814ca802aa6bdda7c28f09f3aba"); // éléphant
		maxLength = 6;

		HashMap<String, String> result = brute.bruteForceShared(list, method, maxLength, threadCount);
		
		assertEquals(null, result.get("8a668814ca802aa6bdda7c28f09f3aba"));
	}
}