package utils;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;
import java.util.Iterator;

public class BruteForceClient implements Runnable {
	Socket sockServer = null;
	
	public BruteForceClient(){}

	public void run (){
		try {
			InetSocketAddress address = new InetSocketAddress("192.168.56.101", 1042);
			ServerSocketChannel serverChannel = ServerSocketChannel.open();
		
			serverChannel.configureBlocking(false);
			serverChannel.socket().bind(address);
			
			Selector selector = Selector.open();
	
			serverChannel.register(selector, SelectionKey.OP_ACCEPT);
	
			while(selector.select() > 0) {
				Iterator<SelectionKey> keys = selector.selectedKeys().iterator();
	
				while(keys.hasNext()) {
					SelectionKey key = keys.next();
					keys.remove();
	
					if(key.isValid() && key.isAcceptable()) {
						ServerSocketChannel server = (ServerSocketChannel) key.channel();
						SocketChannel client = server.accept();
						client.configureBlocking(false);
						
						client.register(selector, SelectionKey.OP_READ | SelectionKey.OP_WRITE);
						
					}
					
					if(key.isValid() && key.isReadable()) {
						SocketChannel client = (SocketChannel) key.channel();
						try {
							ByteBuffer buffer = ByteBuffer.allocate(1000);
							
							int bitsLus = client.read(buffer);
							if(bitsLus>0)
								System.out.println("Recu : " + new String(buffer.array(), 0, bitsLus));
						}
						catch(Exception e) {
							e.printStackTrace();
							key.cancel();
							client.close();
						}
					}
				}
			}
			
			selector.close();
			
			serverChannel.close();
		} catch (IOException e1) {
			e1.printStackTrace();
		}
	}

	public static void main (String args[]) throws Exception{
		new BruteForceClient().run();
	}
}
