package utils;

import java.util.ArrayList;
import java.util.HashMap;

public class BruteForceResult {
	private HashMap<String,String> results;
	private HashMap<String, String> currents;
	private int threadDone;
	private int threadCount;
	
	public BruteForceResult(ArrayList<String> list, int threadCount){
		this.results = new HashMap<String, String>();
		this.currents = new HashMap<String, String>();
		this.threadDone = 0;
		this.threadCount = threadCount;
		for(String encrypted : list)
			addEncrypted(encrypted);
	}
	
	public BruteForceResult(ArrayList<String> list){
		this(list,0);
	}

	public BruteForceResult(String encrypted, int threadCount){
		this(new ArrayList<String>(), threadCount);
		addEncrypted(encrypted);
	}
	
	public BruteForceResult(String encrypted){
		this(new ArrayList<String>(), 0);
		addEncrypted(encrypted);
	}
	
	public boolean isFound(){
		return currents.isEmpty();
	}
	
	public boolean isFound(String encrypted){
		return results.containsKey(encrypted);
	}
	
	public void addEncrypted(String encrypted){
		currents.put(encrypted, null);
	}
	
	public void setResult(String encrypted, String value){
		if(!results.containsKey(encrypted))
			results.put(encrypted, value);
		currents.remove(encrypted);
	}
	
	public boolean contains(String encrypted){
		return currents.containsKey(encrypted);
	}
	
	public boolean isAllThreadDone(){
		return (this.threadCount == this.threadDone);
	}
	
	public void addThreadDone(){
		++threadDone;
	}
	
	@SuppressWarnings("unchecked")
	public HashMap<String, String> getResults(){
		return (HashMap<String, String>) results.clone();
	}
}
