package utils;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Random;


public class RainbowTable {

	public static final int NbTables = 1;
	int id;
	static int lengthPassword;
	public static final int NbFonctionsReduce = 30;
	public static final int NbPassword = 5000;
	ArrayList<String> mdp;
	ArrayList<String> hachesFinaux;
	ArrayList<String> mdpGeneresParUneLigne;

	public RainbowTable(int id, int lgPswd) {
		this.id = id;
		lengthPassword = lgPswd;
		mdp = new ArrayList<String>();
		for(int i=0;i<NbPassword;i++) {
			String pwd = randomPassword(lengthPassword); 
			mdp.add(pwd);
		}
		hachesFinaux = new ArrayList<String>();
	}	

	public void generateTable() throws HashingException, IOException {
		for(int i=0;i<NbPassword;i++) {
			generateLigne(i);
		}
		BufferedWriter buf = new BufferedWriter(new FileWriter("RainbowTable"+id+".txt"));
		for(int j=0;j<mdp.size();j++) {
			buf.write(mdp.get(j)+" -> "+hachesFinaux.get(j));
			buf.newLine();
		}
		buf.close();
	}
	
	public void generateLigne(int i) throws HashingException {
		String mdp_i = mdp.get(i);
		String hache_i = Hash.hash(mdp_i);
		for(int j=0;j<NbFonctionsReduce;j++) {
			mdp_i = reduce(0,hache_i,lengthPassword);
			hache_i = Hash.hash(mdp_i);
		}
		hachesFinaux.add(i,hache_i);
	}
	
	public static String reduce(int i, String hache,int lg) {
		String[] blocs = new String[lg];
		int[] res = new int[lg];

		for(int j=0;j<lg;j++) {
			blocs[j] = hache.substring(j,j+32/lg);
			for(int k=0;k<blocs[j].length();k++) {
				res[j] += blocs[j].charAt(k);
			}
		}

		String pwd = "";
		for(int j=0;j<res.length;j++) {
			res[j] = transforme(res[j]);//+i);
			pwd += (char)res[j];
		}
		return pwd;
	}


	public String randomPassword(int lg) {
		String pwd = "";
		Random r = new Random();
		int c;
		for(int i=0;i<lg;i++) {
			c = r.nextInt(123456789);
			c = transforme(c);
			pwd += (char) c;
		}
		return pwd;
	}

	public static int transforme(int c) {
		int n = c%123;
		if(n<48)
			return transforme(n+48);
		if(n<65 && n>57) {
			if(n-2*(57+65)/3>=0)
				return transforme(65);
			return transforme(57);
		}
		if(n<97 && n>90){
			if(n-2*(97+90)/3>=0)
				return transforme(97);
			return transforme(90);
		}
		return n;
	}


}
